----------------------------------------------------------------------------------
-- Company: 
-- Engineer: Liam Gow
-- 
-- Create Date:    11:19:12 11/17/2014 
-- Design Name: 
-- Module Name:    Countdown - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
-- Countdown decrements a counter on the rising edge of secondCLK
-- The time limit/initial value must be manually changed where indicated below
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Countdown is
    Port ( Reset : in STD_LOGIC;
			secondCLK : in  STD_LOGIC;
			win : in STD_LOGIC;
			limit : out STD_LOGIC_VECTOR (7 downto 0);
			timer : out  STD_LOGIC_VECTOR (7 downto 0));
end Countdown;

architecture Behavioral of Countdown is

	constant timeLimit: integer := 60 + 1; -- time limit: the first period is short, so we add one to the 'official' limit
	 
begin

	limit <= std_logic_vector(to_unsigned(timeLimit, 8));

countdown : process (secondCLK, reset, win)

	variable seconds : std_logic_vector (7 downto 0) := std_logic_vector(to_unsigned(timeLimit, 8));
	
begin

	if reset = '1' then
		seconds := std_logic_vector(to_unsigned(timeLimit, 8));
	end if;

	if(rising_edge(secondCLK)) then
		if(seconds > 0 and win = '0') then
			seconds := seconds - '1';
		end if;
	end if;
	
	timer <= seconds;

end process;

end Behavioral;

