----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    10:32:53 11/13/2014 
-- Design Name: 
-- Module Name:    MazeArray - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity MazeArray is
    Port ( Direction : in  STD_LOGIC_VECTOR (2 downto 0);
			  Board : in STD_LOGIC_VECTOR (3 downto 0);
			  Reset : in STD_LOGIC;
           Valid : out  STD_LOGIC;
           Win : out  STD_LOGIC);
end MazeArray;

-- Direction 0 is null, 1-4 clockwise from top

-- Symbols are for use in the maze array initialization, to be Replaced (Ctrl+H) with their binary values

-- 000 : ! : 0 is a blank wall space
-- 001 : @ : 1 is a wall
-- 010 : # : 2 is a blank player space
-- 011 : $ : 3 is a player
-- 100 : % : 4 is the starting point
-- 101 : ^ : 5 is the ending point

architecture Behavioral of MazeArray is

type maze_data is array (2 downto 0) of std_logic_vector;
type maze is array (0 to 32, 0 to 32) of maze_data;
type nibble is array (3 downto 0) of std_logic_vector;
type coords is array (0 to 1) of integer;

variable maze : maze;
variable player : coords;

begin

intialize : process (reset)
begin
	if reset = '1' then
		case board is 
	--	when "0000" => maze := (
		when others => maze := (
	--  1,2,3,4,5,6,7,8,9,A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X
	--  -,O,-,O,-,O,-,O,-,O,-,O,-,O,-,O,-,O,-,O,-,O,-,O,-,O,-,O,-,O,-,O,-
		(@,@,@,@,@,@,@,@,@,@,@,@,@,@,@,%,@,@,@,@,@,@,@,@,@,@,@,@,@,@,@,@,@) -- -
		(@,#,!,#,!,#,!
	-- ...
		(@,@,@,@,@,@,@,@,@,@,@,@,@,@,@,@,^,@,@,@,@,@,@,@,@,@,@,@,@,@,@,@,@));-- -

		player := (15, 1);
	end if;
end process;

-- Make this an FSM!
update_board : process (direction)
	variable new_player
begin
	if direction = "001" then
		new_player := (player(0), player(1)+1);
		maze(player(0), player(1)) := "010";
		maze(new_player(0), new_player(1)) := "011";
		player := (new_player(0), new_player(1));
	elsif direction = "010" then


end process;
	

end Behavioral;

